From 73a641861fb7151410f783acae7824dc8ce89bd9 Mon Sep 17 00:00:00 2001
From: Alistair Francis <alistair@alistair23.me>
Date: Tue, 24 Aug 2021 21:12:46 +1000
Subject: [PATCH 1/4] Cargo: Update the glib dependencies

Update libhandy to 0.8 to allow using libhandy 1.0. In order for this to
build we also update the glib and gtk dependencies.

Signed-off-by: Alistair Francis <alistair@alistair23.me>
---
 Cargo.lock                         | 3408 +++++++++++++++++-----------
 Cargo.toml                         |   21 +-
 data/resources/ui/articles_list.ui |    4 +-
 data/resources/ui/login.ui.in      |   14 +-
 data/resources/ui/settings.ui      |   10 +-
 data/resources/ui/window.ui.in     |    4 +-
 meson.build                        |    2 +-
 src/application.rs                 |   28 +-
 src/database.rs                    |    2 +-
 src/main.rs                        |    5 +-
 src/meson.build                    |    1 -
 src/models/article.rs              |    2 +-
 src/models/client_manager.rs       |    2 +-
 src/models/object_wrapper.rs       |   74 +-
 src/models/preview_image.rs        |    4 +-
 src/settings/settings_manager.rs   |   21 +-
 src/static_resources.rs.in         |    2 +-
 src/views/articles_list.rs         |    4 +-
 src/widgets/articles/index.rs      |   23 +-
 src/widgets/articles/list.rs       |   10 +-
 src/widgets/articles/preview.rs    |   14 +-
 src/widgets/articles/row.rs        |    2 +-
 src/widgets/login.rs               |   24 +-
 src/widgets/settings.rs            |    9 +-
 src/widgets/window.rs              |   66 +-
 src/window_state.rs                |   34 -
 26 files changed, 2247 insertions(+), 1543 deletions(-)
 delete mode 100644 src/window_state.rs

diff --git a/Cargo.toml b/Cargo.toml
index 5a4f00b..e010fa7 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -5,21 +5,21 @@ authors = ["Bilal Elmoussaoui <bil.elmoussaoui@gmail.com>"]
 edition = "2018"
 
 [dependencies]
-gtk = { version = "0.8", features = ["v3_22"] }
-glib = "0.9"
-gio = { version = "0.8", features = ["v2_56"] }
-cairo-rs = "0.8"
-gdk = "0.12"
-gdk-pixbuf = "0.8"
+gtk = { version = "0.14", features = ["v3_22"] }
+glib = "0.14"
+gio = { version = "0.14", features = ["v2_64"] }
+cairo-rs = "0.14"
+gdk = "0.14"
+gdk-pixbuf = "0.14"
 log = "0.4"
-libhandy = "0.5"
-webkit2gtk = { version = "0.9", features = ["v2_6"] }
+libhandy = "0.8"
+webkit2gtk = { version = "0.14", features = ["v2_6"] }
 gettext-rs= { version = "0.4", features = ["gettext-system"] }
 lazy_static = "1.3"
 serde = "1.0"
 serde_json = "1.0"
 serde_derive = "1.0"
-wallabag-api = { git = "https://github.com/swalladge/wallabag-api.git", rev = "d2bbebbe76f44edc074e3b2f5313bb8861b6cbe4" }
+wallabag-api = "0.4.1"
 pretty_env_logger = "0.3"
 diesel = { version = "1.4", features = ["sqlite", "r2d2", "chrono"] }
 diesel_migrations = {  version = "1.4", features = ["sqlite"] }
@@ -36,5 +36,6 @@ html2pango = "0.3"
 rust-crypto = "0.2"
 async-std = "1.4"
 futures = { version = "0.3", features = [ "thread-pool" ] }
-gtk-macros = "0.2"
+gtk-macros = "0.3"
 http-client = { version = "1.1", features = ["native_client"] }
+once_cell = "1.8.0"
diff --git a/data/resources/ui/articles_list.ui b/data/resources/ui/articles_list.ui
index 611b362..cae1e3b 100644
--- a/data/resources/ui/articles_list.ui
+++ b/data/resources/ui/articles_list.ui
@@ -3,11 +3,9 @@
 <interface>
   <requires lib="gtk+" version="3.20"/>
   <requires lib="libhandy" version="0.0"/>
-  <object class="HdyColumn" id="articles_list">
+  <object class="HdyClamp" id="articles_list">
     <property name="visible">True</property>
     <property name="can_focus">False</property>
-    <property name="maximum_width">800</property>
-    <property name="linear_growth_width">800</property>
     <child>
       <object class="GtkStack" id="stack">
         <property name="visible">True</property>
diff --git a/data/resources/ui/login.ui.in b/data/resources/ui/login.ui.in
index d7c03be..f0935d6 100644
--- a/data/resources/ui/login.ui.in
+++ b/data/resources/ui/login.ui.in
@@ -20,11 +20,9 @@
       </attributes>
     </child>
   </object>
-  <object class="HdyColumn" id="login">
+  <object class="HdyClamp" id="login">
     <property name="visible">True</property>
     <property name="can_focus">False</property>
-    <property name="maximum_width">450</property>
-    <property name="linear_growth_width">450</property>
     <child>
       <object class="GtkBox">
         <property name="visible">True</property>
@@ -111,7 +109,7 @@
                 <property name="can_focus">True</property>
                 <property name="activatable">False</property>
                 <property name="title" translatable="yes">Instance URL</property>
-                <child type="action">
+                <child>
                   <object class="GtkEntry" id="instance_entry">
                     <property name="visible">True</property>
                     <property name="can_focus">True</property>
@@ -127,7 +125,7 @@
                 <property name="visible">True</property>
                 <property name="can_focus">True</property>
                 <property name="title" translatable="yes">Client ID</property>
-                <child type="action">
+                <child>
                   <object class="GtkEntry" id="client_id_entry">
                     <property name="visible">True</property>
                     <property name="can_focus">True</property>
@@ -142,7 +140,7 @@
                 <property name="visible">True</property>
                 <property name="can_focus">True</property>
                 <property name="title" translatable="yes">Client Secret</property>
-                <child type="action">
+                <child>
                   <object class="GtkEntry" id="client_secret_entry">
                     <property name="visible">True</property>
                     <property name="can_focus">True</property>
@@ -159,7 +157,7 @@
                 <property name="visible">True</property>
                 <property name="can_focus">True</property>
                 <property name="title" translatable="yes">Username</property>
-                <child type="action">
+                <child>
                   <object class="GtkEntry" id="username_entry">
                     <property name="visible">True</property>
                     <property name="can_focus">True</property>
@@ -174,7 +172,7 @@
                 <property name="visible">True</property>
                 <property name="can_focus">True</property>
                 <property name="title" translatable="yes">Password</property>
-                <child type="action">
+                <child>
                   <object class="GtkEntry" id="password_entry">
                     <property name="visible">True</property>
                     <property name="can_focus">True</property>
diff --git a/data/resources/ui/settings.ui b/data/resources/ui/settings.ui
index aa16664..0cf5ffb 100644
--- a/data/resources/ui/settings.ui
+++ b/data/resources/ui/settings.ui
@@ -18,7 +18,7 @@
               <object class="HdyActionRow">
                 <property name="title" translatable="yes">Enable dark mode</property>
                 <property name="visible">True</property>
-                <child type="action">
+                <child>
                   <object class="GtkSwitch" id="dark_mode_button">
                     <property name="can_focus">True</property>
                     <property name="valign">center</property>
@@ -44,7 +44,7 @@
               <object class="HdyActionRow">
                 <property name="title" translatable="yes">Username</property>
                 <property name="visible">True</property>
-                <child type="action">
+                <child>
                   <object class="GtkLabel" id="username_label">
                     <property name="visible">True</property>
                     <property name="can_focus">True</property>
@@ -58,7 +58,7 @@
               <object class="HdyActionRow">
                 <property name="title" translatable="yes">Email</property>
                 <property name="visible">True</property>
-                <child type="action">
+                <child>
                   <object class="GtkLabel" id="email_label">
                     <property name="visible">True</property>
                     <property name="can_focus">True</property>
@@ -72,7 +72,7 @@
               <object class="HdyActionRow">
                 <property name="title" translatable="yes">Created At</property>
                 <property name="visible">True</property>
-                <child type="action">
+                <child>
                   <object class="GtkLabel" id="created_at_label">
                     <property name="visible">True</property>
                     <property name="can_focus">False</property>
@@ -86,7 +86,7 @@
               <object class="HdyActionRow">
                 <property name="title" translatable="yes">Updated At</property>
                 <property name="visible">True</property>
-                <child type="action">
+                <child>
                   <object class="GtkLabel" id="updated_at_label">
                     <property name="visible">True</property>
                     <property name="can_focus">False</property>
diff --git a/data/resources/ui/window.ui.in b/data/resources/ui/window.ui.in
index 709d455..68961ae 100644
--- a/data/resources/ui/window.ui.in
+++ b/data/resources/ui/window.ui.in
@@ -258,11 +258,9 @@
               </object>
             </child>
             <child type="title">
-              <object class="HdyColumn">
+              <object class="HdyClamp">
                 <property name="visible">True</property>
                 <property name="can_focus">False</property>
-                <property name="maximum_width">500</property>
-                <property name="linear_growth_width">500</property>
                 <property name="hexpand">True</property>
                 <child>
                   <object class="GtkEntry" id="article_url_entry">
diff --git a/meson.build b/meson.build
index f11aa4f..b10ef62 100644
--- a/meson.build
+++ b/meson.build
@@ -11,7 +11,7 @@ dependency('glib-2.0', version: '>= 2.56')
 dependency('gio-2.0', version: '>= 2.56')
 dependency('gdk-pixbuf-2.0')
 dependency('gtk+-3.0', version: '>= 3.24.7')
-dependency('libhandy-0.0', version: '>= 0.0.10')
+dependency('libhandy-1', version: '>= 0.0.10')
 
 version = meson.project_version()
 version_array = version.split('.')
diff --git a/src/application.rs b/src/application.rs
index 71cfd2f..cb127d1 100644
--- a/src/application.rs
+++ b/src/application.rs
@@ -11,7 +11,6 @@ use futures::executor::ThreadPool;
 use gio::prelude::*;
 use glib::{Receiver, Sender};
 use gtk::prelude::*;
-use std::env;
 use std::{cell::RefCell, rc::Rc};
 use url::Url;
 
@@ -40,7 +39,7 @@ pub struct Application {
 
 impl Application {
     pub fn new() -> Rc<Self> {
-        let app = gtk::Application::new(Some(config::APP_ID), gio::ApplicationFlags::FLAGS_NONE).unwrap();
+        let app = gtk::Application::new(Some(config::APP_ID), gio::ApplicationFlags::FLAGS_NONE);
 
         let (sender, r) = glib::MainContext::channel(glib::PRIORITY_DEFAULT);
         let receiver = RefCell::new(Some(r));
@@ -68,8 +67,7 @@ impl Application {
         let receiver = self.receiver.borrow_mut().take().unwrap();
         receiver.attach(None, move |action| app.do_action(action));
 
-        let args: Vec<String> = env::args().collect();
-        self.app.run(&args);
+        self.app.run();
     }
 
     fn init(&self) {
@@ -129,7 +127,7 @@ impl Application {
             clone!(@strong self.window.widget as window, @strong self.client as client =>  move |_, _| {
                 let settings_widget = SettingsWidget::new(client.clone());
                 settings_widget.widget.set_transient_for(Some(&window));
-                let size = window.get_size();
+                let size = window.size();
                 settings_widget.widget.resize(size.0, size.1);
                 settings_widget.widget.show();
             })
@@ -139,11 +137,13 @@ impl Application {
             self.app,
             "about",
             clone!(@strong self.window.widget as window => move |_, _| {
-                let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/about_dialog.ui");
+                let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/about_dialog.ui");
                 get_widget!(builder, gtk::AboutDialog, about_dialog);
 
                 about_dialog.set_transient_for(Some(&window));
-                about_dialog.connect_response(|dialog, _| dialog.destroy());
+                unsafe {
+                    about_dialog.connect_response(|dialog, _| dialog.destroy());
+                }
                 about_dialog.show();
             })
         );
@@ -192,19 +192,19 @@ impl Application {
             window.present();
         });
 
-        if let Some(gtk_settings) = gtk::Settings::get_default() {
+        if let Some(gtk_settings) = gtk::Settings::default() {
             SettingsManager::bind_property(Key::DarkMode, &gtk_settings, "gtk-application-prefer-dark-theme");
         }
     }
 
     fn setup_css(&self) {
-        if let Some(theme) = gtk::IconTheme::get_default() {
+        if let Some(theme) = gtk::IconTheme::default() {
             theme.add_resource_path("/com/belmoussaoui/ReadItLater/icons");
         }
 
         let p = gtk::CssProvider::new();
         gtk::CssProvider::load_from_resource(&p, "/com/belmoussaoui/ReadItLater/style.css");
-        if let Some(screen) = gdk::Screen::get_default() {
+        if let Some(screen) = gdk::Screen::default() {
             gtk::StyleContext::add_provider_for_screen(&screen, &p, 500);
         }
     }
@@ -213,7 +213,7 @@ impl Application {
      * Auth
      */
     fn init_client(&self) {
-        let username = SettingsManager::get_string(Key::Username);
+        let username = SettingsManager::string(Key::Username);
         match SecretManager::is_logged(&username) {
             Ok(config) => {
                 send!(self.sender, Action::SetView(View::Articles));
@@ -227,7 +227,7 @@ impl Application {
         send!(self.sender, Action::SetView(View::Syncing(true)));
         let client = self.client.clone();
         let sender = self.sender.clone();
-        let logged_username = SettingsManager::get_string(Key::Username);
+        let logged_username = SettingsManager::string(Key::Username);
 
         spawn!(async move {
             let mut client = client.lock().await;
@@ -261,7 +261,7 @@ impl Application {
     }
 
     fn logout(&self) -> Result<()> {
-        let username = SettingsManager::get_string(Key::Username);
+        let username = SettingsManager::string(Key::Username);
         database::wipe()?;
         self.window.articles_view.clear();
         if SecretManager::logout(&username).is_ok() {
@@ -275,7 +275,7 @@ impl Application {
     fn sync(&self) {
         send!(self.sender, Action::SetView(View::Syncing(true)));
         let mut since = Utc.timestamp(0, 0);
-        let last_sync = SettingsManager::get_integer(Key::LatestSync);
+        let last_sync = SettingsManager::integer(Key::LatestSync);
         if last_sync != 0 {
             since = Utc.timestamp(last_sync.into(), 0);
         }
diff --git a/src/database.rs b/src/database.rs
index b9722b4..7b4a98b 100644
--- a/src/database.rs
+++ b/src/database.rs
@@ -8,7 +8,7 @@ use std::{fs, fs::File};
 type Pool = r2d2::Pool<ConnectionManager<SqliteConnection>>;
 
 lazy_static! {
-    static ref DB_PATH: PathBuf = glib::get_user_data_dir().unwrap().join("read-it-later");
+    static ref DB_PATH: PathBuf = glib::user_cache_dir().join("read-it-later");
     static ref POOL: Pool = init_pool().expect("Failed to create a Pool");
 }
 
diff --git a/src/main.rs b/src/main.rs
index 0e36028..5b93108 100644
--- a/src/main.rs
+++ b/src/main.rs
@@ -16,7 +16,7 @@ extern crate strum_macros;
 extern crate gtk_macros;
 
 use gettextrs::*;
-use libhandy::Column;
+use libhandy;
 
 mod application;
 mod config;
@@ -27,7 +27,6 @@ mod settings;
 mod static_resources;
 mod views;
 mod widgets;
-mod window_state;
 
 use application::Application;
 
@@ -44,7 +43,7 @@ fn main() {
     glib::set_application_name(&format!("Read It Later{}", config::NAME_SUFFIX));
 
     static_resources::init().expect("Failed to initialize the resource file.");
-    Column::new(); // Due to libhandy not having a main func :(
+    libhandy::init();
     webkit2gtk::WebView::new();
 
     let app = Application::new();
diff --git a/src/meson.build b/src/meson.build
index d515ced..f523525 100644
--- a/src/meson.build
+++ b/src/meson.build
@@ -67,7 +67,6 @@ sources = files(
   'main.rs',
   'schema.rs',
   'static_resources.rs',
-  'window_state.rs',
 )
 
 custom_target('cargo-build',
diff --git a/src/models/article.rs b/src/models/article.rs
index 78f27aa..cafe87f 100644
--- a/src/models/article.rs
+++ b/src/models/article.rs
@@ -177,7 +177,7 @@ impl Article {
                 preview_image.download(client).await?;
             }
 
-            return Ok(Some(gdk_pixbuf::Pixbuf::new_from_file(&preview_image.cache)?));
+            return Ok(Some(gdk_pixbuf::Pixbuf::from_file(&preview_image.cache)?));
         }
         Ok(None)
     }
diff --git a/src/models/client_manager.rs b/src/models/client_manager.rs
index f747c1b..e043e86 100644
--- a/src/models/client_manager.rs
+++ b/src/models/client_manager.rs
@@ -48,7 +48,7 @@ impl ClientManager {
         debug!("[Client] Saving url {}", url);
         if let Some(client) = self.client.clone() {
             let mut client = client.lock().await;
-            let new_entry = NewEntry::new_with_url(url.into_string());
+            let new_entry = NewEntry::new_with_url(url.into());
             if let Ok(entry) = client.create_entry(&new_entry).await {
                 let article = Article::from(entry);
                 send!(self.sender, Action::Articles(Box::new(ArticleAction::Add(article))));
diff --git a/src/models/object_wrapper.rs b/src/models/object_wrapper.rs
index e0d6f34..3b9b50c 100644
--- a/src/models/object_wrapper.rs
+++ b/src/models/object_wrapper.rs
@@ -5,42 +5,26 @@
 // https://github.com/gtk-rs/examples/blob/master/src/bin/listbox_model.rs
 // Source https://gitlab.gnome.org/World/Shortwave/blob/master/src/model/object_wrapper.rs
 
-use gtk::prelude::*;
+use gtk::{glib, prelude::*};
 use serde::de::DeserializeOwned;
 
-use glib::subclass;
 use glib::subclass::prelude::*;
-use glib::translate::*;
+use glib::{ParamSpec, Value};
 
 mod imp {
     use super::*;
     use std::cell::RefCell;
 
+    #[derive(Default)]
     pub struct ObjectWrapper {
         data: RefCell<Option<String>>,
     }
 
-    static PROPERTIES: [subclass::Property; 1] = [subclass::Property("data", |name| {
-        glib::ParamSpec::string(
-            name,
-            "Data",
-            "Data",
-            None, // Default value
-            glib::ParamFlags::READWRITE,
-        )
-    })];
-
+    #[glib::object_subclass]
     impl ObjectSubclass for ObjectWrapper {
         const NAME: &'static str = "ObjectWrapper";
+        type Type = super::ObjectWrapper;
         type ParentType = glib::Object;
-        type Instance = subclass::simple::InstanceStruct<Self>;
-        type Class = subclass::simple::ClassStruct<Self>;
-
-        glib_object_subclass!();
-
-        fn class_init(klass: &mut Self::Class) {
-            klass.install_properties(&PROPERTIES);
-        }
 
         fn new() -> Self {
             Self { data: RefCell::new(None) }
@@ -48,13 +32,24 @@ mod imp {
     }
 
     impl ObjectImpl for ObjectWrapper {
-        glib_object_impl!();
-
-        fn set_property(&self, _obj: &glib::Object, id: usize, value: &glib::Value) {
-            let prop = &PROPERTIES[id];
+        fn properties() -> &'static [glib::ParamSpec] {
+            use once_cell::sync::Lazy;
+            static PROPERTIES: Lazy<Vec<glib::ParamSpec>> = Lazy::new(|| {
+                vec![glib::ParamSpec::new_string(
+                    "data",
+                    "Data",
+                    "Data",
+                    None, // Default value
+                    glib::ParamFlags::READWRITE,
+                )]
+            });
+
+            PROPERTIES.as_ref()
+        }
 
-            match *prop {
-                subclass::Property("data", ..) => {
+        fn set_property(&self, _obj: &Self::Type, _id: usize, value: &Value, pspec: &ParamSpec) {
+            match pspec.name() {
+                "data" => {
                     let data = value.get().expect("Failed to get `data` property");
                     self.data.replace(data);
                 }
@@ -62,23 +57,17 @@ mod imp {
             }
         }
 
-        fn get_property(&self, _obj: &glib::Object, id: usize) -> Result<glib::Value, ()> {
-            let prop = &PROPERTIES[id];
-
-            match *prop {
-                subclass::Property("data", ..) => Ok(self.data.borrow().to_value()),
+        fn property(&self, _obj: &Self::Type, _id: usize, pspec: &glib::ParamSpec) -> glib::Value {
+            match pspec.name() {
+                "data" => self.data.borrow().to_value(),
                 _ => unimplemented!(),
             }
         }
     }
 }
 
-glib_wrapper! {
-    pub struct ObjectWrapper(Object<subclass::simple::InstanceStruct<imp::ObjectWrapper>, subclass::simple::ClassStruct<imp::ObjectWrapper>, ObjectWrapperClass>);
-
-    match fn {
-        get_type => || imp::ObjectWrapper::get_type().to_glib(),
-    }
+glib::wrapper! {
+    pub struct ObjectWrapper(ObjectSubclass<imp::ObjectWrapper>);
 }
 
 impl ObjectWrapper {
@@ -86,17 +75,14 @@ impl ObjectWrapper {
     where
         O: serde::ser::Serialize,
     {
-        glib::Object::new(Self::static_type(), &[("data", &serde_json::to_string(&object).unwrap())])
-            .unwrap()
-            .downcast()
-            .unwrap()
+        glib::Object::new(&[("data", &serde_json::to_string(&object).unwrap())]).unwrap()
     }
 
     pub fn deserialize<O>(&self) -> O
     where
         O: DeserializeOwned,
     {
-        let data = self.get_property("data").unwrap().get::<String>().unwrap();
-        serde_json::from_str(&data.unwrap()).unwrap()
+        let data = self.property("data").unwrap().get::<String>().unwrap();
+        serde_json::from_str(&data).unwrap()
     }
 }
diff --git a/src/models/preview_image.rs b/src/models/preview_image.rs
index 0a7668f..3b9b7c4 100644
--- a/src/models/preview_image.rs
+++ b/src/models/preview_image.rs
@@ -7,7 +7,7 @@ use std::rc::Rc;
 use url::Url;
 
 lazy_static! {
-    pub static ref CACHE_DIR: PathBuf = glib::get_user_cache_dir().unwrap().join("read-it-later");
+    pub static ref CACHE_DIR: PathBuf = glib::user_cache_dir().join("read-it-later");
 }
 
 pub struct PreviewImage {
@@ -17,7 +17,7 @@ pub struct PreviewImage {
 
 impl PreviewImage {
     pub fn new(url: Url) -> Self {
-        let cache = PreviewImage::get_cache_of(&url.clone().into_string());
+        let cache = PreviewImage::get_cache_of(&String::from(url.clone()));
         Self { url, cache }
     }
 
diff --git a/src/settings/settings_manager.rs b/src/settings/settings_manager.rs
index 0484672..a2ed150 100644
--- a/src/settings/settings_manager.rs
+++ b/src/settings/settings_manager.rs
@@ -18,12 +18,12 @@ impl SettingsManager {
 
     pub fn bind_property<P: IsA<glib::Object>>(key: Key, object: &P, property: &str) {
         let settings = Self::get_settings();
-        settings.bind(key.to_string().as_str(), object, property, gio::SettingsBindFlags::DEFAULT);
+        settings.bind(key.to_string().as_str(), object, property).build();
     }
 
-    pub fn get_string(key: Key) -> String {
+    pub fn string(key: Key) -> String {
         let settings = Self::get_settings();
-        settings.get_string(&key.to_string()).unwrap().to_string()
+        settings.string(&key.to_string()).to_string()
     }
 
     pub fn set_string(key: Key, value: String) {
@@ -33,21 +33,14 @@ impl SettingsManager {
         }
     }
 
-    pub fn get_boolean(key: Key) -> bool {
+    pub fn boolean(key: Key) -> bool {
         let settings = Self::get_settings();
-        settings.get_boolean(&key.to_string())
+        settings.boolean(&key.to_string())
     }
 
-    pub fn set_boolean(key: Key, value: bool) {
+    pub fn integer(key: Key) -> i32 {
         let settings = Self::get_settings();
-        if let Err(err) = settings.set_boolean(&key.to_string(), value) {
-            error!("Failed to save {} setting due to {}", key.to_string(), err);
-        }
-    }
-
-    pub fn get_integer(key: Key) -> i32 {
-        let settings = Self::get_settings();
-        settings.get_int(&key.to_string())
+        settings.int(&key.to_string())
     }
 
     pub fn set_integer(key: Key, value: i32) {
diff --git a/src/static_resources.rs.in b/src/static_resources.rs.in
index 9ffb7bb..6fb8d29 100644
--- a/src/static_resources.rs.in
+++ b/src/static_resources.rs.in
@@ -10,7 +10,7 @@ pub(crate) fn init() -> Result<(), Error> {
 
     // Create Resource it will live as long the value lives.
     let gbytes = Bytes::from_static(res_bytes.as_ref());
-    let resource = Resource::new_from_data(&gbytes)?;
+    let resource = Resource::from_data(&gbytes)?;
 
     // Register the resource so it won't be dropped and will continue to live in
     // memory.
diff --git a/src/views/articles_list.rs b/src/views/articles_list.rs
index 16d6771..8d270ff 100644
--- a/src/views/articles_list.rs
+++ b/src/views/articles_list.rs
@@ -57,7 +57,7 @@ impl ArticlesListView {
     }
 
     pub fn len(&self) -> u32 {
-        self.model.get_n_items()
+        self.model.n_items()
     }
 
     pub fn delete(&self, article: &Article) {
@@ -86,7 +86,7 @@ impl ArticlesListView {
 
     fn index(&self, article: &Article) -> Option<u32> {
         for i in 0..self.len() {
-            let gobject = self.model.get_object(i).unwrap();
+            let gobject = self.model.item(i).unwrap();
             let a: Article = gobject.downcast_ref::<ObjectWrapper>().unwrap().deserialize();
 
             if article.id == a.id {
diff --git a/src/widgets/articles/index.rs b/src/widgets/articles/index.rs
index 19ba129..665652e 100644
--- a/src/widgets/articles/index.rs
+++ b/src/widgets/articles/index.rs
@@ -3,7 +3,8 @@ use gio::prelude::*;
 use glib::Sender;
 use gtk::prelude::*;
 use std::{cell::RefCell, rc::Rc};
-use webkit2gtk::{ContextMenuExt, ContextMenuItemExt, WebView, WebViewExt};
+use webkit2gtk::traits::{ContextMenuExt, ContextMenuItemExt, WebViewExt};
+use webkit2gtk::WebView;
 
 use crate::models::{Article, ArticleAction};
 use crate::settings::{Key, SettingsManager};
@@ -18,7 +19,7 @@ pub struct ArticleWidget {
 
 impl ArticleWidget {
     pub fn new(sender: Sender<ArticleAction>) -> Rc<Self> {
-        let builder = gtk::Builder::new_from_resource("/com/belmoussaoui/ReadItLater/article.ui");
+        let builder = gtk::Builder::from_resource("/com/belmoussaoui/ReadItLater/article.ui");
         get_widget!(builder, gtk::Box, article);
 
         let actions = gio::SimpleActionGroup::new();
@@ -48,8 +49,8 @@ impl ArticleWidget {
         get_widget!(self.builder, WebView, webview);
 
         webview.connect_context_menu(move |_, context_menu, _, _| {
-            for menu_item in context_menu.get_items() {
-                let action = menu_item.get_stock_action();
+            for menu_item in context_menu.items() {
+                let action = menu_item.stock_action();
 
                 if forbidden_actions.contains(&action) {
                     // Remove forbidden actions
@@ -62,8 +63,8 @@ impl ArticleWidget {
         // Progress bar
         get_widget!(self.builder, gtk::Revealer, revealer);
         get_widget!(self.builder, gtk::ProgressBar, progressbar);
-        webview.connect_property_estimated_load_progress_notify(move |webview| {
-            let progress = webview.get_estimated_load_progress();
+        webview.connect_estimated_load_progress_notify(move |webview| {
+            let progress = webview.estimated_load_progress();
             revealer.set_reveal_child(true);
             progressbar.set_fraction(progress);
             if (progress - 1.0).abs() < std::f64::EPSILON {
@@ -91,7 +92,7 @@ impl ArticleWidget {
                 if let Some(article) = aw.article.borrow().clone() {
                     glib::idle_add(clone!(@strong article => move || {
                         let article_url = article.url.clone();
-                        let screen = gdk::Screen::get_default().unwrap();
+                        let screen = gdk::Screen::default().unwrap();
                         if let Err(err_msg) = gtk::show_uri(Some(&screen), &article_url.unwrap(), 0) {
                             error!("Failed to open the uri {} in the default browser", err_msg);
                         }
@@ -106,7 +107,7 @@ impl ArticleWidget {
             "archive",
             false,
             clone!(@strong aw, @strong self.sender as sender => move |action, _|{
-                let state = action.get_state().unwrap();
+                let state = action.state().unwrap();
                 let action_state: bool = state.get().unwrap();
                 let is_archived = !action_state;
                 action.set_state(&is_archived.to_variant());
@@ -121,7 +122,7 @@ impl ArticleWidget {
             "favorite",
             false,
             clone!(@strong aw, @strong self.sender as sender => move |action, _|{
-                let state = action.get_state().unwrap();
+                let state = action.state().unwrap();
                 let action_state: bool = state.get().unwrap();
                 let is_starred = !action_state;
                 action.set_state(&is_starred.to_variant());
@@ -153,7 +154,7 @@ impl ArticleWidget {
         }
 
         let mut layout_css = load_resource("layout.css")?;
-        if SettingsManager::get_boolean(Key::DarkMode) {
+        if SettingsManager::boolean(Key::DarkMode) {
             layout_css.push_str(&load_resource("layout-dark.css")?);
         }
         layout_html = layout_html.replace("{css}", &layout_css);
@@ -167,7 +168,7 @@ impl ArticleWidget {
 }
 
 pub fn load_resource(file: &str) -> Result<String> {
-    let file = gio::File::new_for_uri(&format!("resource:///com/belmoussaoui/ReadItLater/{}", file));
+    let file = gio::File::for_uri(&format!("resource:///com/belmoussaoui/ReadItLater/{}", file));
     let (bytes, _) = file.load_bytes(gio::NONE_CANCELLABLE)?;
     String::from_utf8(bytes.to_vec()).map_err(From::from)
 }
